function s=fm_osc(t0,a,f,ph0);

global Fs; global SpF; %global variables: sample rate, samples-per-frame

nframes=length(a);          %total number of frames
s=zeros(1,nframes*SpF);     %initialize signal vector to 0
lastf=f(1); lastph=ph0;     %initialize frequency, phase

for (i=1:nframes)
   phase=zeros(1,SpF);       %phase vector in a frame
   for(k=1:SpF)  % work at sample rate
      phase(k)=lastph + pi/Fs*(f((i-1)*SpF+k)+lastf); %compute phase
      lastph=phase(k); lastf=f((i-1)*SpF+k);          %save last values
   end
   s(((i-1)*SpF+1):i*SpF)=a(i).*sin(phase);
end
s=[zeros(1,round(t0*Fs)) s]; %add initial silence of t0 sec.

