[s, Fs] = wavread('la.wav');   %%%% input file

%% analysis parameters
N=2048;                   %block length
Sa=256;                   %analysis hop-size
p=round(Fs/1000)+4 ;      %prediction order
win=hamming(N)';          %' window for input block

M = ceil(length(s)/Sa);     %number of frames in the signal
s(M*Sa+N)=0;                %now s is exactly M*Sa samples

for i=0:M-1   %%% frame-by-frame analysis
  frame=s( (i*Sa+1):(i*Sa+N) );
  [a,g]=lp_coeffs(frame, p); % compute LP coeffs
  x=filter(a,g,frame);       % X(z)=A(z)/g * S(z), i.e. x[n] = e[n]/g
  frameSpec= abs(fft(frame)); [H,F]=freqz(g,a,N,Fs);
  figure(1); clf; plot(frame); hold on; plot(x,'r'); grid on;
  figure(2); clf; plot(F,20*log10(frameSpec)); hold on; grid on;
   plot(F,20*log10(abs(H)),'r'); axis([0 5000 0 max(20*log10(frameSpec))]); 
   pause;
end
