function y = sola_timestretch(x,N,Sa,alpha,L)
%N: block length; Sa: analysis hop-size; alpha: stretch factor; L: overlap int. 

Ss = round(Sa*alpha); %synthesis hop-size
if ( (Sa > N) || (Ss >= N) || Ss > N-L) error('Wrong parameter values!'); end
if (rem(L,2)~= 0)   L = L+1; end

M = ceil(length(x)/Sa);   %number of frames
x(M*Sa+N)=0;              %now x is exactly M*Sa samples
y(1:N,1) =  x(1:N);         %first frame of x is written into y;

for m=1:M-1    %loop over frames 
  frame=x(m*Sa+1:N+m*Sa);   %current analysis frame
  framecorr=xcorr(frame(1:L),y(m*Ss:m*Ss+(L-1)));		
  [corrmax,imax]=max(framecorr);  %find point of max xcorrelation

  fade = (m*Ss-(L-1)+imax-1):length(y);     %points for crossfade
  fadein = (0:length(fade)-1)/length(fade); %from 0 to 1
  fadeout = 1 - fadein;                     %from 1 to 0
  y=[y(1:(fade(1)-1)); (y(fade).*fadeout' +frame(1:length(fade)).*fadein'); ...
     frame(length(fade)+1:length(frame))];
end


