function s = waveosc(t0,a,f,ph0,wavetype,npart);
%%%% param wavetype can be 'cos' | 'square' | 'triang' | 'saw' | 'imp' %%%%

global Fs; global SpF;  %global variables: sample rate, samples-per-frame

npart = min(npart, floor(Fs/(2*max(f)))); % max. no of partials up to Nyquist
nframes=length(a); s=zeros(1,nframes*SpF); %initialize signal vector to 0
switch (wavetype)
  case {'cos'};    
  s=sinosc(t0,a,f,ph0);
  case {'square'}; 
  for (k=1:npart) s=s+4/pi*sinosc(t0,a,(2*k-1)*f,ph0-pi/2)/(2*k-1); end
  case {'triang'};
  for (k=1:npart) s=s+8/pi^2*(-1)^k*sinosc(t0,a,(2*k-1)*f,ph0-pi/2)/(2*k-1)^2; end
  case {'saw'};    
  for (k=1:npart) s=s-2/pi*sinosc(t0,a,k*f,ph0-pi/2)/k; end    
  case {'imp'};
  for (k=1:npart) s= s + sinosc(t0,a,k*f,ph0)/(1+npart); end   
end
